'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _cliTable = require('cli-table');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _variants = require('../../variants.json');

var _variants2 = _interopRequireDefault(_variants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

_commander2.default.parse(process.argv);

if (!_commander2.default.args.length) {
    _commander2.default.help();
}

if (_commander2.default.args.length < 1) {
    console.log(_chalk2.default.red('Please provide the variant name!!!'));
    process.exit(1);
}

// Check whether the given variant is available or not
var selectedVariant = _variants2.default.filter(function (variant) {
    return variant.name === _commander2.default.args[0];
})[0];
if (!selectedVariant) {
    console.log(_chalk2.default.red.bold(_commander2.default.args[0] + ' is not a valid MERN variant. Execute \'mern list\' to list available variants'));
    process.exit(1);
}

// Process the variants json file into an array
var selectedVariantArr = Object.keys(selectedVariant).map(function (k) {
    var obj = {};
    obj[k.charAt(0).toUpperCase() + k.slice(1)] = selectedVariant[k];
    return obj;
});

// Show all the variants in a table
var variantsTable = new _cliTable2.default();
variantsTable.push.apply(variantsTable, _toConsumableArray(selectedVariantArr));
console.log(variantsTable.toString());
process.exit(0);